package route

import (
	"net/http"

	"github.com/pkg/errors"
	"gitlab.com/wpetit/goweb/middleware/container"
	"gitlab.com/wpetit/goweb/service/template"
)

func extendTemplateData(w http.ResponseWriter, r *http.Request, data template.Data) template.Data {
	ctn := container.Must(r.Context())
	data, err := template.Extend(data,
		template.WithBuildInfo(w, r, ctn),
	)

	if err != nil {
		panic(errors.Wrap(err, "could not extend template data"))
	}

	return data
}
